import { DataSource, ViewEntity, ViewColumn } from 'typeorm';
import { Carrera } from '../../../institucion-carrera/entity/carrera.entity';
import { Institucion } from '../../../institucion/entity/institucion.entity';
import { InstitucionCarrera } from '../../../institucion-carrera/entity/institucion-carrera.entity';
import { InstitucionUsuario } from '../institucion-usuario.entity';

@ViewEntity({
  expression: (dataSource: DataSource) =>
    dataSource
      .createQueryBuilder()
      .select('iu.id_institucion_usuario', 'id_institucion_usuario')
      .addSelect('iu.activo', 'activo')
      .addSelect('iu.multa', 'multa')
      .addSelect('iu.id_institucion_carrera', 'id_institucion_carrera')
      .addSelect('iu.id_usuario', 'id_usuario')
      .addSelect('ic.id_carrera', 'id_carrera')
      .addSelect('ic.id_institucion', 'id_institucion')
      .addSelect('c.carrera', 'carrera')
      .addSelect('i.institucion', 'institucion')
      .from(InstitucionUsuario, 'iu')
      .innerJoin(
        InstitucionCarrera,
        'ic',
        'ic.id_institucion_carrera = iu.id_institucion_carrera',
      )
      .innerJoin(Carrera, 'c', 'c.id_carrera = ic.id_carrera')
      .innerJoin(Institucion, 'i', 'i.id_institucion = ic.id_institucion'),
})
export class FullInformacionInstitucionUsuarioView {
  @ViewColumn()
  id_carrera: number;

  @ViewColumn()
  activo: number;

  @ViewColumn()
  carrera: string;

  @ViewColumn()
  institucion: string;

  @ViewColumn()
  id_institucion: number;

  @ViewColumn()
  id_institucion_carrera: number;

  @ViewColumn()
  id_institucion_usuario: number;

  @ViewColumn()
  id_usuario: number;

  @ViewColumn()
  multa: number;
}
