import { Module } from '@nestjs/common';
import { PassportModule } from '@nestjs/passport';
import { TypeOrmModule } from '@nestjs/typeorm';
import { InstitucionUsuarioService } from './institucion-usuario.service';
import { InstitucionUsuario } from './entity/institucion-usuario.entity';
import { FullInformacionInstitucionUsuarioView } from './entity/views/full-informacion-institucion-usuario.view';
import { InformacionInstitucionUsuarioView } from './entity/views/informacion-institucion-usuario.view';
import { InstitucionUsuarioController } from './institucion-usuario.controller';

@Module({
  imports: [
    PassportModule.register({ defaultStrategy: 'jwt' }),
    TypeOrmModule.forFeature([
      InstitucionUsuario,
      FullInformacionInstitucionUsuarioView,
      InformacionInstitucionUsuarioView,
    ]),
  ],
  providers: [InstitucionUsuarioService],
  exports: [InstitucionUsuarioService],
  controllers: [InstitucionUsuarioController],
})
export class InstitucionUsuarioModule {}
